// gridTotalSIBUC.cc
// SIBUC ˤäƷ׻줿ʬή褫ή̤ϥǡȤ
// ƻ׻Ԥ

#include <stdio.h>
#include <time.h>

#include "total.h"
#include "p_tmp.h"
#include "gridSub.cc"

/*-----------------------------
 饹 GridRiverBasin 
-------------------------------*/

class GridRiverBasin : public Total_system {

protected:
  char gidx_fname[50];             // å()ξ򵭤ե
  char gc_fname[50];               // å()֤³򵭤ե
  char linfo_fname[50];            // ήǲήüˤĤƤΥե
  int Num_of_suikei;               // Ͽ
  int Num_of_op;                   // ϥե
  int i, j;

  // ¤(struct RiverSystem)
  struct RiverSystem{
    GridSub obj;                  // (ʬϤѿ̾)
    char obj_name[50];             // ʬϤΥ֥̾
    int num_up_inside;             // ޳ξήü
    int num_up_online;             // վξήü
    int num_down_inside;           // ޳βήü
    int num_down_online;           // վβήü
    char sub_c_fname[50];          // ƻʬ³ե̾
    int lat_unit;                  // ¦ή̤ñ(2 or 3)
    int nseg;                      // ƻʬ
    char slp_ob_name[50];          // ǤΥ֥̾
    int slp_ob_num;                // ǤΥֹ֥
    char net_ob_name[50];          // ƻǤΥ֥̾
    int net_ob_num;                // ƻǤΥֹ֥
    char rain_fname[50];           // ߿̤Υե̾
    char evapo_fname[50];          // ȯ̤Υե̾
  };
  struct RiverSystem* rSys;
  
protected:
  // ü
  I_file<double> ipu;              // ǾήüǤή(Ѱ)
  I_file<double>* ipp;             // ߿(ϤοѰ)
  I_file<double>* ipe;             // ȯ(ϤοѰ)

  // üҤϿ
  void Register_input_ports(void)
    {
      Register((void*) &ipu);
      for(i = 0; i < Num_of_suikei; i++){
	Register((void*) &ipe[i]);
	Register((void*) &ipp[i]);
      }
    }
 
protected:
  // ü(ϥեοѰ)
  O_file<double>* op;

  // üҤϿ
  void Register_output_ports(void)
    {
      for(i = 0; i < Num_of_op; i++){
	Register((void*) &op[i]);
      }
    }

protected:
  // ǤϿ
  void Register_components(void);

  // Ǵȿ׻ѤδؿʤΤǡȤʤ
  void Register_iterators(void) {}

protected:
  // üҤ³
  void Connect_ports(void);
  
  // ľ̿ѤδؿʤΤǡȤʤ
  void Connect_components(void) {}

public:
  // ֤
  virtual void Set_initial_state(FILE* fp)
    {
      fscanf(fp, "%ld", &current_time);
    }

public:
  // 󥹥ȥ饯
  GridRiverBasin(char* o_name,           // ηϤΥ֥̾
		 int o_num,              // ηϤΥֹ֥
		 int num_it,             // ȿ׻롼׿
		 char* g_idx_file,       // ϤΥǥåե
		 char* g_connect_file,   // Ϥɤ³ե
		 char* lowest_info_file, // Ͼե
		 char* u_file,           // ήüήե
		 int num_suikei,         // Ͽ
		 int num_op,             // ϥե
		 int tStepSlp,           // Ǥνϻֳִ
		 int tStepNet            // ƻǤνϻֳִ
		 );

public:
  // ǥȥ饯
  ~GridRiverBasin(void)
    {
      delete [] rSys;
      delete [] ipp;
      delete [] ipe;
      delete [] op;
    }

public:
  // ؿ
  Boolean Init(char* o_name, int o_num, int num_it, 
	       char* g_idx_file, char* g_connect_file,
	       char* lowest_info_file, char* u_file,
	       int num_suikei, int num_op, int tStepSlp, int tStepNet);
};


/*----------------------------
 饹 GridRiverBasin μ¸ 
------------------------------*/

// ǤϿ
void GridRiverBasin::Register_components(void)
{
  for(i = 0; i < Num_of_suikei; i++){
    Register((void*) &(rSys[i].obj));
  }
}

// üҤ³
void GridRiverBasin::Connect_ports(void)
{

  // ήüήե(ipu)ȳʬϤĤʤ

  for(i = 0; i < Num_of_suikei; i++){
    for(j = 0; j < rSys[i].num_up_inside; j++){
      Connect(((void*) &ipu), ((void*) &(rSys[i].obj)), "Relay", "rp_U", j);

//      printf("ipu -> %s (rp_U, %d)\n", rSys[i].obj_name, j);
    }
  }

  // ȯ̥ե(ipe[i])ȳʬϤĤʤ
  // ̥߱ե(ipp[i])ȳʬϤĤʤ

  for(i = 0; i < Num_of_suikei; i++){
    Connect(((void*) &ipe[i]), ((void*) &(rSys[i].obj)), "Relay", "rp_E", 0);
    Connect(((void*) &ipp[i]), ((void*) &(rSys[i].obj)), "Relay", "rp_P", 0);

//    printf("ipe[%d] -> %s (rp_E, 0)\n", i, rSys[i].obj_name);
//    printf("ipp[%d] -> %s (rp_P, 0)\n", i, rSys[i].obj_name);
  }

  // ʬϥǥɤĤʤ

  char buf[256];
  int send_o_num, receive_o_num;        // üҤΥֹ֥
  char d_ob_name[50];                   // ή¦ʬϤΥ֥̾
  char u_ob_name[50];                   // ή¦ʬϤΥ֥̾
  int d_num, u_num;                     // ʬϤΥǥåֹ
                                        //  ( rSys[i]  i  )
  FILE* fp;
  if((fp = fopen(gc_fname, "r")) == NULL){
    Eprint(__FILE__, __LINE__);
    // GridRiverBasin::Connect_ports
    // Cannot open GridConnect file.
    Oprint();
    exit(1);
  }
  while(fgets(buf, 256, fp) != NULL){

    // ȡԤν
    if((buf[0] == '\n') || (buf[0] == '#')) continue;

    if(sscanf(buf, "%s %d %s %d", d_ob_name, &receive_o_num,
	      u_ob_name, &send_o_num) != 4){
      Eprint(__FILE__, __LINE__);
      // GridRiverBasin::Connect_ports
      // Cannot scan Grid-Connect information.
      Oprint();
      exit(1);
    }
    /* d_num 롣*/
    for(i = 0; i < Num_of_suikei; i++){
      if(strcmp(rSys[i].obj_name, d_ob_name) == 0){
	d_num = i;
	break;
      }
    }
    /* u_num 롣*/
    for(i = 0; i < Num_of_suikei; i++){
      if(strcmp(rSys[i].obj_name, u_ob_name) == 0){
	u_num = i;
	break;
      }
    }

    /* üҤĤʤ */
    Connect(((void*) &(rSys[u_num].obj)), "Relay", "sp_O", send_o_num,
	    ((void*) &(rSys[d_num].obj)), "Relay", "rp_U", receive_o_num);

//    printf("%s (sp_O, %d) -> %s (rp_U, %d)\n",
//	   rSys[u_num].obj_name, send_o_num,
//	   rSys[d_num].obj_name, receive_o_num);
  }

  fclose(fp);

  // ʬϤή̥ե(op[i])Ĥʤ

  fp = fopen(linfo_fname, "r");
  char tmp[50];
  i = 0;
  while(fgets(buf, 256, fp) != NULL){
    if((buf[0] == '#') || (buf[0] == '\n')) continue;
    if(sscanf(buf, "%s %d %s", u_ob_name, &send_o_num, tmp) == 3){

      /* u_num  */
      for(j = 0; j < Num_of_suikei; j++){
	if(strcmp(rSys[j].obj_name, u_ob_name) == 0){
	  u_num = j;
	  break;
	}
      }

      /* üҤĤʤ */
      Connect(((void*) &(rSys[u_num].obj)), "Relay", "sp_O", send_o_num,
	      ((void*) &op[i]));
//      printf("%s (sp_O, %d) -> op[%d]\n", rSys[u_num].obj_name,
//	     send_o_num, i);

      i++;
    }
  }

  fclose(fp);
}

// 󥹥ȥ饯
GridRiverBasin::GridRiverBasin(char* o_name,
			       int o_num,
			       int num_it,
			       char* g_idx_file,
			       char* g_connect_file,
			       char* lowest_info_file,
			       char* u_file,
			       int num_suikei,
			       int num_op,
			       int tStepSlp,
			       int tStepNet
			       ) 
:      Total_system()
{
  class_name = "GridRiverBasin";

  // ηϥ饹 
  // ("֥̾", "ֹ֥", "ȿ׻롼פο",
  //  "åɤΥǥåե̾", "åɤ³ե̾",
  //  "ǲήüե̾", "å()", "Ͽ", 
  //  "Ǥνϻֳִ", "ƻǤνϻֳִ")
  Init(o_name, o_num, num_it, g_idx_file, g_connect_file, 
       lowest_info_file, u_file, num_suikei, num_op, tStepSlp, tStepNet);
}

// ؿ
Boolean GridRiverBasin::Init(char* o_name,
			     int o_num,
			     int num_it, 
			     char* g_idx_file,
			     char* g_connect_file,
			     char* lowest_info_file,
			     char* u_file,
			     int num_suikei, 
			     int num_op,
			     int tStepSlp,
			     int tStepNet
			     )
{
  FILE* fp;
  char buf[256];

  /* Num_of_suikei */
  if(num_suikei <= 0){
    Eprint(__FILE__, __LINE__);
    // GridRiverBasin::Init
    // 'num_suikei' must be natural number.
    Oprint();
    exit(1);
  }
  Num_of_suikei = num_suikei;

  // γ
  rSys = new RiverSystem[Num_of_suikei];

  /* Num_of_op */
  if(num_op <= 0){
    Eprint(__FILE__, __LINE__);
    // GridRiverBasin::Init
    // 'num_op' must be natural number.
    Oprint();
    exit(1);
  }
  Num_of_op = num_op;

  // ϡüҤν

  ipu.Init(u_file);

  if((ipp = new I_file<double>[Num_of_suikei]) == NULL){
    Eprint_memory(__FILE__, __LINE__);
    // GridRiverBasin::Init
    // Cannot allocate memory for ipp.
    Oprint();
    exit(1);
  }

  if((ipe = new I_file<double>[Num_of_suikei]) == NULL){
    Eprint_memory(__FILE__, __LINE__);
    // GridRiverBasin::Init
    // Cannot allocate memory for ipe.
    Oprint();
    exit(1);
  }

  if((op = new O_file<double>[Num_of_op]) == NULL){
    Eprint_memory(__FILE__, __LINE__);
    // GridRiverBasin::Init
    // Cannot allocate memory for op.
    Oprint();
    exit(1);
  }

  // ե̾
//   Set_data_string(g_idx_file);
//   if(sscanf(data_string, "%s", gidx_fname) != 1){
  if(sscanf(g_idx_file, "%s", gidx_fname) != 1){
    Eprint(__FILE__, __LINE__);
    // GridRiverBasin::Init
    // Cannot scan filename for grid information.
    Oprint();
    exit(1);
  }
//  Clear_data_string();

//   Set_data_string(g_connect_file);
//   if(sscanf(data_string, "%s", gc_fname) != 1){
   if(sscanf(g_connect_file, "%s", gc_fname) != 1){
    Eprint(__FILE__, __LINE__);
    // GridRiverBasin::Init
    // Cannot scan filename for grid connection.
    Oprint();
    exit(1);
  }
//  Clear_data_string();

//   Set_data_string(lowest_info_file);
//   if(sscanf(data_string, "%s", linfo_fname) != 1){
  if(sscanf(lowest_info_file, "%s", linfo_fname) != 1){
    Eprint(__FILE__, __LINE__);
    // GridRiverBasin::Init
    // Cannot scan filename for grid information.
    Oprint();
    exit(1);
  }
//  Clear_data_string();
  

  // ǥåե뤫ɤ߼äǼƤ

  if((fp = fopen(gidx_fname, "r")) == NULL){
    Eprint(__FILE__, __LINE__);
    // GridRiverBasin::Init
    // Cannot open grid information file.
    Oprint();
    exit(1);
  }

  int u_inside, u_online, d_inside, d_online, l_uni, n_seg;
  int slp_obj_no, net_obj_no;
  char ob_name[50], scf_name[50], sl_obj[50];
  char net_obj[50], r_fname[50], e_fname[50];
  int n_up = 0, n_down = 0;
  i = 0;
  while(fgets(buf, 256, fp) != NULL){
    if(i == Num_of_suikei){
      // եοϤ¿
      Eprint(__FILE__, __LINE__);
      // GridRiverBasin::Init
      // Too many information in grid_idx_file.
      Oprint();
      exit(1);
    }
    // ȡԤν
    if((buf[0] == '#') || (buf[0] == '\n')) continue;

    if(sscanf(buf, "%s %d %d %d %d %s %d %d %s %d %s %d %s %s", 
	      ob_name, &u_inside, &u_online, &d_inside, &d_online, 
	      scf_name, &l_uni, &n_seg, sl_obj, &slp_obj_no,
	      net_obj, &net_obj_no, r_fname, e_fname) != 14){
      Eprint(__FILE__, __LINE__);
      // GridRiverBasin::Init
      // Cannot scan grid information.
      Oprint();
      exit(1);
    }

    // γǼ
    strcpy(rSys[i].obj_name, ob_name);
    rSys[i].num_up_inside = u_inside;
    rSys[i].num_up_online = u_online;
    rSys[i].num_down_inside = d_inside;
    rSys[i].num_down_online = d_online;
    strcpy(rSys[i].sub_c_fname, scf_name);
    rSys[i].lat_unit = l_uni;
    rSys[i].nseg = n_seg;
    strcpy(rSys[i].slp_ob_name, sl_obj);
    rSys[i].slp_ob_num = slp_obj_no;
    strcpy(rSys[i].net_ob_name, net_obj);
    rSys[i].net_ob_num = net_obj_no;
    strcpy(rSys[i].rain_fname, r_fname);
    strcpy(rSys[i].evapo_fname, e_fname);

    n_up = rSys[i].num_up_inside + rSys[i].num_up_online;
    n_down = rSys[i].num_down_inside + rSys[i].num_down_online;

    /* rSys[i].obj ν */
    rSys[i].obj.Init(rSys[i].obj_name, 0, rSys[i].sub_c_fname, n_up, 1,
		     rSys[i].lat_unit, rSys[i].nseg, n_down, 
		     rSys[i].slp_ob_name, rSys[i].slp_ob_num, tStepSlp,
		     rSys[i].net_ob_name, rSys[i].net_ob_num, tStepNet);

    /* ipp[i], ipe[i] ν */
    ipp[i].Init(rSys[i].rain_fname);
    ipe[i].Init(rSys[i].evapo_fname);

    //    printf("%s    %s\n", ipp[i].Object_name(), ipe[i].Object_name());
    i++;
  }
  fclose(fp);

  if(i < Num_of_suikei - 1){
    // եοϤ­Ƥ
    Eprint(__FILE__, __LINE__);
    // GridRiverBasin::Init
    // Too few information in grid_idx_file.
    Oprint();
    exit(1);
  }

  char tmp_o_name[50], op_fname[50];
  int tmp_sp_num;
  if((fp = fopen(linfo_fname, "r")) == NULL){
	  printf("%s\n",linfo_fname);
    Eprint(__FILE__, __LINE__);
    // GridRiverBasin::Init
    // Cannot open the File about Lowest Points.
    Oprint();
    exit(1);
  }

  i = -1;
  while(fgets(buf, 256, fp) != NULL){
    if(i == Num_of_op){
      printf("i = %d, Num_of_op = %d\n", i, Num_of_op);
      // 󤬲
      Eprint(__FILE__, __LINE__);
      // GridRiverBasin::Init
      // Too many infomation about Lowest points.
      Oprint();
      exit(1);
    }

    // ȡԤν
    if((buf[0] == '#') || (buf[0] == '\n')) continue;
    i++;
    if(sscanf(buf, "%s %d %s", tmp_o_name, &tmp_sp_num, op_fname) != 3){
      Eprint(__FILE__, __LINE__);
      // GridRiverBasin::Init
      // Cannot scan Lowest point information.
      Oprint();
      exit(1);
    }
    /* op[i] ν */
    op[i].Init(op_fname);

  }
  if(i < Num_of_op - 1){
    // ­
    Eprint(__FILE__, __LINE__);
    // GridRiverBasin::Init
    // Too few infomation about Lowest points.
    Oprint();
    exit(1);
  }
  fclose(fp);

  return Total_system :: Init(o_name, o_num, num_it);
}


/*----------------
 ᥤץ
------------------*/

int main(void)
{
  // ηϥǥ
  GridRiverBasin grb(
		     "grb",               // ηϤΥ֥̾
		     0,                   // ηϤΥֹ֥
		     0,                   // ȿ׻롼פο
		     "suikeiSIBUC.idx",      // ƿϤˤĤƤΥե
		     "subsystem.connect",  // ϤɤηҤ򵭤ե
		     "output_points.info",// ϥե̾˴ؤե
		     "i.up",              // ήüή̥ե̾
		     1472,                   // Ͽ
		     1,                   // ϥե
		     3600,                // Ǥνϻֳִ()
		     3600                 // ƻǤνϻֳִ()
		     );

  if (grb.Construct() != YES)
    { printf("\n# Failure : Construct.\n"); return 1; }

  if (grb.Switch() != YES)
    { printf("\n# Failure : Switch.\n"); return 1; }
  
  if (grb.Are_you_ready() != YES)
    { printf("\n# Failure : Are_you_ready.\n"); return 1; }

  // ѥ᥿ե뤫ɤߤȤ
  grb.Read_parameter_file("all_grid.pmtV3");
  
  // ֤ե뤫ɤߤȤ
  grb.Read_initial_state_file("all_grid.ist");

  // üҥǡꥹȥ
  grb.Read_send_port_file("all_grid.isd");
	
  grb.Initial_work();
  grb.Work();
	
  // ǽ֤ե¸
  grb.Write_terminal_state("all_grid.tst");

  // üҤ˻ĤäƤǡե¸
  grb.Write_send_port_stock("all_grid.tsd");

  return 0;
}
