/* xaj.h
-------------------------------------------------
  Xaj : ά¹ǥ(ήХǥ)
-------------------------------------------------
*/

#if !defined(_xaj_h)
#define _xaj_h

#include <stdio.h>
#include <stdlib.h>

#include "common.h"                                    /* ̴Ķ */
#include "element.h"                            /* 饹 Element  */
#include "p_tmp.h"            /* ƥץ졼ȥ饹 Receive, Send  */

class Xaj : public Element{

  /* ѥ᥿ */
 protected:
  double Ai;                                        /* ԿƩΨ */
  double b;                   /* ǽϤζʬ۷ѥ᥿ */
  double Wm;                                   /* ήα (mm) */
  double kg;                                   /* ǥ (1/mm/ISEC)*/
  double c_area;                                     /* ή (km^2) */
  // ϥѥ᥿ե뤫ɤ߼롣

  int ISEC;                                       /* ׻ֳִ (sec) */
  // 󥹥ȥ饯ΰȤͿ롣

  double Im;                                   /* αǽϤκ (mm) */
//  time_t dt;                                        /* ॹƥå */

  /*  */
 protected:
  double W;                              /* ߻Ǥήα (mm) */
  double I;                        /* ˰ΰǤκǽ (mm) */
  double storage;                                    /* ϲα (mm) */
  double P;                                          /* ߿ (mm/day) */
  double E;                                        /* ȯ (mm/day) */
  double P_effec;                                 /* ͭ߱ (mm/ISEC) */
  double Qi;                            /* ԿƩ褫ή (mm/ISEC) */
  double Qp;              /* Ʃ褫 storage ؤȲäή(mm/ISEC) */
  double Qs;                            /* ϲαή (mm/ISEC) */
  double Q;                                           /* ή (mm/ISEC) */
  time_t T;                                           /* ϻ (sec) */
  double discharge;                        /* ή褫ή(m^3/sec) */

  double Q_sum, sum_total, P_effec_sum;
  double storage_init, W_init;
  // Ϣ³طĴ٤뤿ѿ

  /* ü, ü */
 protected:
  Receive<double> rp_p;
  // ֥̾ rp_p, ֹ֥ 0
  Receive<double> rp_e;
  // ֥̾ rp_e, ֹ֥ 0
  Send<double> sp;
  // ֥̾ sp, ֹ֥ 0

  /* ü, üҤϿ */
 protected:
  void Register_receive_ports(void);
  void Register_send_ports(void);

  /* ؿ, 󥹥ȥ饯, ǥȥ饯 */
 private:
  // ػߤ뤿. ʤ.
  Xaj& operator=(const Xaj& rhs);

 public:
  Boolean Init(char* o_name, int o_num, int ISEC_tmp);

  Xaj(char* o_name, int o_num, int ISEC_tmp);
  // class_name  "Xaj" ꤷ, object_name  o_name ,
  // ׻ֳִ֤ ISEC_tmp ꤹ.

  Xaj(void);

  ~Xaj(void){}

  /* ѥ᥿ꡦ̤ν */
 public:
  void Set_parameter(FILE* fp);
  // ԿƩΨ(Ai), ǽϤζʬ۷ѥ᥿(b),
  // ήα̤κ(Wm), ǥ(kg), ή(c_area) 
  // , αǽϤκ(Im)׻.
  // -----------------------------
  // ѥ᥿ѥեν 
  // -----------------------------
  // Ai, b, Wm, kg, c_area(km^2) ν˰Ԥ˵.
  //
  // ()
  //     0.02 0.7 260.0 0.01 1000.0
   
  void Set_initial_state(FILE* fp);
  // (tnow)ˤ˰ΰǤκαǽ(I), 
  // λǤϲα(storage)ꤷ, λǤ
  // ήα(W)׻.
  // -----------------------------
  // ѥեν
  // -----------------------------
  // tnow, I, storage ν˰Ԥ˵.
  //
  // ()
  //     0 2.0 10.0
 
  void Save_terminal_state(FILE* fp);
  // ǽ֤ե˽Ϥ.

 public:
  Boolean Initial_output(void);
  time_t Calculate_time_step(void) { return ISEC; }
  Boolean Can_you_calculate(void) { return Can_you_calculate0(); }
  Boolean Calculate(void);
  Boolean Work(void) { return Work0(); }
};

#endif
